diff -urN --exclude .git --exclude po/ --exclude '*.pyc' --exclude '.*.swp' anaconda/storage/deviceaction.py anaconda-storage/storage/deviceaction.py
--- anaconda/storage/deviceaction.py	1969-12-31 18:00:00.000000000 -0600
+++ anaconda-storage/storage/deviceaction.py	2009-02-12 16:17:59.000000000 -0600
@@ -0,0 +1,293 @@
+# deviceaction.py
+# Device modification action classes for anaconda's storage configuration
+# module.
+#
+# Copyright (C) 2009  Red Hat, Inc.
+#
+# This copyrighted material is made available to anyone wishing to use,
+# modify, copy, or redistribute it subject to the terms and conditions of
+# the GNU General Public License v.2, or (at your option) any later version.
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY expressed or implied, including the implied warranties of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
+# Public License for more details.  You should have received a copy of the
+# GNU General Public License along with this program; if not, write to the
+# Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.  Any Red Hat trademarks that are incorporated in the
+# source code or documentation are not subject to the GNU General Public
+# License and may only be used or replicated with the express permission of
+# Red Hat, Inc.
+#
+# Red Hat Author(s): Dave Lehman <dlehman@redhat.com>
+#
+""" action.py
+
+"""
+from devices import StorageDevice
+from errors import *
+
+import gettext
+_ = lambda x: gettext.ldgettext("anaconda", x)
+
+import logging
+log = logging.getLogger("storage")
+
+
+""" The values are just hints as to the ordering.
+
+    Eg: fsmod and devmod ordering depends on the mod (shrink -v- grow)
+"""
+ACTION_TYPE_NONE = 0
+ACTION_TYPE_DESTROY = 1000
+ACTION_TYPE_RESIZE = 500
+ACTION_TYPE_CREATE = 250
+
+action_strings = {ACTION_TYPE_NONE: "None",
+                  ACTION_TYPE_DESTROY: "Destroy",
+                  ACTION_TYPE_RESIZE: "Resize",
+                  ACTION_TYPE_CREATE: "Create"}
+
+ACTION_OBJECT_NONE = 0
+ACTION_OBJECT_FORMAT = 1
+ACTION_OBJECT_DEVICE = 2
+
+object_strings = {ACTION_OBJECT_NONE: "None",
+                  ACTION_OBJECT_FORMAT: "Format",
+                  ACTION_OBJECT_DEVICE: "Device"}
+
+RESIZE_SHRINK = 88
+RESIZE_GROW = 89
+
+resize_strings = {RESIZE_SHRINK: "Shrink",
+                  RESIZE_GROW: "Grow"}
+
+class DeviceAction(object):
+    """ An action that will be carried out in the future on a Device.
+
+        These classes represent actions to be performed on devices or
+        filesystems.
+
+        The operand Device instance will be modified according to the
+        action, but no changes will be made to the underlying device or
+        filesystem until the DeviceAction instance's execute method is
+        called. The DeviceAction instance's cancel method should reverse
+        any modifications made to the Device instance's attributes.
+
+        If the Device instance represents a pre-existing device, the
+        constructor should call any methods or set any attributes that the
+        action will eventually change. Device/DeviceFormat classes should verify
+        that the requested modifications are reasonable and raise an
+        exception if not.
+
+        Only one action of any given type/object pair can exist for any
+        given device at any given time. This is enforced by the
+        DeviceTree.
+
+        Basic usage:
+
+            a = DeviceAction(dev)
+            a.execute()
+
+            OR
+
+            a = DeviceAction(dev)
+            a.cancel()
+
+
+        XXX should we back up the device with a deep copy for forcibly
+            cancelling actions?
+
+            The downside is that we lose any checking or verification that
+            would get done when resetting the Device instance's attributes to
+            their original values.
+
+            The upside is that we would be guaranteed to achieve a total
+            reversal. No chance of, eg: resizes ending up altering Device
+            size due to rounding or other miscalculation.
+"""
+    type = ACTION_TYPE_NONE
+    obj = ACTION_OBJECT_NONE
+
+    def __init__(self, device):
+        if not isinstance(device, StorageDevice):
+            raise ValueError("arg 1 must be a StorageDevice instance")
+        self.device = device
+        #self._backup = deepcopy(device)
+
+    def execute(self):
+        """ perform the action """
+        pass
+
+    def cancel(self):
+        """ cancel the action """
+        pass
+
+    def isDestroy(self):
+        return self.type == ACTION_TYPE_DESTROY
+
+    def isCreate(self):
+        return self.type == ACTION_TYPE_CREATE
+
+    def isResize(self):
+        return self.type == ACTION_TYPE_RESIZE
+
+    def isShrink(self):
+        return (self.type == ACTION_TYPE_RESIZE and self.dir == RESIZE_SHRINK)
+
+    def isGrow(self):
+        return (self.type == ACTION_TYPE_RESIZE and self.dir == RESIZE_GROW)
+
+    def isDevice(self):
+        return self.obj == ACTION_OBJECT_DEVICE
+
+    def isFormat(self):
+        return self.obj == ACTION_OBJECT_FORMAT
+
+    def __str__(self):
+        s = "%s %s" % (action_strings[self.type], object_strings[self.obj])
+        if self.isResize():
+            s += " (%s)" % resize_strings[self.dir]
+        if self.isFormat():
+            if self.format:
+                fmt_type = self.format.type
+            else:
+                fmt_type = None
+            s += " %s on" % fmt_type
+        s += " %s (%s)" % (self.device.name, self.device.type)
+        return s
+
+class ActionCreateDevice(DeviceAction):
+    """ Action representing the creation of a new device. """
+    type = ACTION_TYPE_CREATE
+    obj = ACTION_OBJECT_DEVICE
+
+    def __init__(self, device):
+        # FIXME: assert device.fs is None
+        DeviceAction.__init__(self, device)
+
+    def execute(self):
+        self.device.create()
+
+
+class ActionDestroyDevice(DeviceAction):
+    """ An action representing the deletion of an existing device. """
+    type = ACTION_TYPE_DESTROY
+    obj = ACTION_OBJECT_DEVICE
+
+    def __init__(self, device):
+        # XXX should we insist that device.fs be None?
+        DeviceAction.__init__(self, device)
+
+    def execute(self):
+        self.device.destroy()
+
+
+class ActionResizeDevice(DeviceAction):
+    """ An action representing the resizing of an existing device. """
+    type = ACTION_TYPE_RESIZE
+    obj = ACTION_OBJECT_DEVICE
+
+    def __init__(self, device, newsize):
+        if device.size == newsize:
+            raise ValueError("new size same as old size")
+
+        DeviceAction.__init__(self, device)
+        if newsize > device.size:
+            self.dir = RESIZE_GROW
+        else:
+            self.dir = RESIZE_SHRINK
+        self.origsize = device.size
+        self.device.size = newsize
+
+    def execute(self):
+        self.device.resize()
+
+    def cancel(self):
+        self.device.size = self.origsize
+
+
+class ActionCreateFormat(DeviceAction):
+    """ An action representing creation of a new filesystem. """
+    type = ACTION_TYPE_CREATE
+    obj = ACTION_OBJECT_FORMAT
+
+    def __init__(self, device, format):
+        DeviceAction.__init__(self, device)
+        # should we insist that device.format be None?
+        # (indicative of ActionDestroyFormat having been instantiated)
+        self.origFormat = device.format
+        self.device.teardownFormat()
+        self.device.setFormat(format)
+
+    def execute(self):
+        # XXX we should set partition type flag as needed
+        #     - or should that be in the CreateDevice action?
+        self.device.setup()
+        self.device.createFormat()
+
+    def cancel(self):
+        self.device.setFormat(self.origFormat)
+
+    @property
+    def format(self):
+        return self.device.format
+
+
+class ActionDestroyFormat(DeviceAction):
+    """ An action representing the removal of an existing filesystem.
+
+        XXX this seems unnecessary
+    """
+    type = ACTION_TYPE_DESTROY
+    obj = ACTION_OBJECT_FORMAT
+
+    def __init__(self, device):
+        DeviceAction.__init__(self, device)
+        self.origFormat = device.format
+        if device.format and device.format.status:
+            device.format.teardown()
+        self.device.setFormat(None)
+
+    def execute(self):
+        """ wipe the filesystem signature from the device """
+        #self.device.destroyFormat()
+        if self.origFormat:
+            self.device.setup()
+            self.origFormat.destroy()
+
+    def cancel(self):
+        self.device.setFormat(self.origFormat)
+
+    @property
+    def format(self):
+        return self.origFormat
+
+
+class ActionResizeFormat(DeviceAction):
+    """ An action representing the resizing of an existing filesystem.
+
+        XXX Do we even want to support resizing of a filesystem without
+            also resizing the device it resides on?
+    """
+    type = ACTION_TYPE_RESIZE
+    obj = ACTION_OBJECT_FORMAT
+
+    def __init__(self, device, newsize):
+        if device.size == newsize:
+            raise ValueError("new size same as old size")
+
+        DeviceAction.__init__(self, device)
+        if newsize > device.format.size:
+            self.dir = RESIZE_GROW
+        else:
+            self.dir = RESIZE_SHRINK
+        self.device.format.setSize(newsize)
+
+    def execute(self):
+        self.device.format.resize()
+
+    def cancel(self):
+        self.device.format.setSize(None)
+
+
+
diff -urN --exclude .git --exclude po/ --exclude '*.pyc' --exclude '.*.swp' anaconda/storage/devicelibs/crypto.py anaconda-storage/storage/devicelibs/crypto.py
--- anaconda/storage/devicelibs/crypto.py	1969-12-31 18:00:00.000000000 -0600
+++ anaconda-storage/storage/devicelibs/crypto.py	2009-02-12 16:17:59.000000000 -0600
@@ -0,0 +1,196 @@
+#
+# crypto.py
+#
+# Copyright (C) 2009  Red Hat, Inc.  All rights reserved.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+# Author(s): Dave Lehman <dlehman@redhat.com>
+#
+
+import iutil
+import os
+
+import gettext
+_ = lambda x: gettext.ldgettext("anaconda", x)
+
+class CryptoError(Exception):
+    pass
+
+def is_luks(device):
+    rc = iutil.execWithRedirect("cryptsetup",
+                                ["isLuks", device],
+                                stdout = "/dev/null",
+                                stderr = "/dev/null",
+                                searchPath = 1)
+    if rc:
+        return False
+    else:
+        return True
+
+def luks_uuid(device):
+    uuid = iutil.execWithCapture("cryptsetup",
+                                 ["luksUUID", device],
+                                 stderr="/dev/null")
+    return uuid.strip()
+
+def luks_status(name):
+    """0 means active, 1 means inactive (or non-existent)"""
+    rc = iutil.execWithRedirect("cryptsetup",
+                                ["status", name],
+                                stdout = "/dev/null",
+                                stderr = "/dev/null",
+                                searchPath = 1)
+    return rc
+
+def luks_format(device,
+                passphrase=None, key_file=None,
+                cipher=None, key_size=None):
+    p = os.pipe()
+    argv = ["-q"]
+    os.close(p[1])
+
+    if cipher:
+        argv.extend(["--cipher", cipher])
+
+    if key_size:
+        argv.append("--key-size=%d" % key_size)
+
+    argv.extend(["luksFormat", device])
+        
+    if passphrase:
+        os.write(p[1], "%s\n" % passphrase)
+    elif key_file and os.path.isfile(key_file):
+        argv.append(key_file)
+    else:
+        raise ValueError("luks_format requires either a passphrase or a key file")
+
+    rc = iutil.execWithRedirect("cryptsetup",
+                                argv,
+                                stdin = p[0],
+                                stdout = "/dev/null",
+                                stderr = "/dev/null",
+                                searchPath = 1)
+
+    os.close(p[0])
+    if rc:
+        raise CryptoError("luks_format failed for '%s'" % device)
+
+def luks_open(device, name, passphrase=None, key_file=None):
+    p = os.pipe()
+    if passphrase:
+        os.write(p[1], "%s\n" % passphrase)
+        argv = ["luksOpen", device, name]
+    elif key_file and os.path.isfile(key_file):
+        argv = ["luksOpen", "--key-file", key_file, device, name]
+    else:
+        raise ValueError("luks_open requires either a passphrase or a key file")
+
+    os.close(p[1])
+    rc = iutil.execWithRedirect("cryptsetup",
+                                argv,
+                                stdin = p[0],
+                                stdout = "/dev/null",
+                                stderr = "/dev/null",
+                                searchPath = 1)
+
+    os.close(p[0])
+    if rc:
+        raise CryptoError("luks_open failed for %s (%s)" % (device, name))
+
+def luks_close(name):
+    rc = iutil.execWithRedirect("cryptsetup",
+                                ["luksClose", name],
+                                stdout = "/dev/null",
+                                stderr = "/dev/null",
+                                searchPath = 1)
+
+    if rc:
+        raise CryptoError("luks_close failed for %s" % name)
+
+def luks_add_key(device,
+                 new_passphrase=None, new_key_file=None,
+                 passphrase=None, key_file=None):
+    p = os.pipe()
+    if passphrase:
+        os.write(p[1], "%s\n" % passphrase)
+        key_spec = ""
+    elif key_file and os.path.isfile(key_file):
+        key_spec = "--key-file %s" % key_file
+    else:
+        raise ValueError("luks_add_key requires either a passphrase or a key file")
+
+    if new_passphrase:
+        os.write(p[1], "%s\n" % new_passphrase)
+        new_key_spec = ""
+    elif new_key_file and os.path.isfile(new_key_file):
+        new_key_spec = "%s" % new_key_file
+    else:
+        raise ValueError("luks_add_key requires either a passphrase or a key file to add")
+
+    os.close(p[1])
+
+    rc = iutil.execWithRedirect("cryptsetup",
+                                ["-q",
+                                 key_spec,
+                                 "luksAddKey",
+                                 device,
+                                 new_key_spec],
+                                stdin = p[0],
+                                stdout = "/dev/null",
+                                stderr = "/dev/null",
+                                searchPath = 1)
+
+    os.close(p[0])
+    if rc:
+        raise CryptoError("luks add key failed")
+
+def luks_remove_key(device,
+                    del_passphrase=None, del_key_file=None,
+                    passphrase=None, key_file=None):
+    p = os.pipe()
+    if passphrase:
+        os.write(p[1], "%s\n" % passphrase)
+        key_spec = ""
+    elif key_file and os.path.isfile(key_file):
+        key_spec = "--key-file %s" % key_file
+    else:
+        raise ValueError("luks_remove_key requires either a passphrase or a key file")
+
+    if del_passphrase:
+        os.write(p[1], "%s\n" % del_passphrase)
+        del_key_spec = ""
+    elif del_key_file and os.path.isfile(del_key_file):
+        del_key_spec = "%s" % del_key_file
+    else:
+        raise ValueError("luks_remove_key requires either a passphrase or a key file to remove")
+
+    os.close(p[1])
+
+    rc = iutil.execWithRedirect("cryptsetup",
+                                ["-q",
+                                 key_spec,
+                                 "luksRemoveKey",
+                                 device,
+                                 del_key_spec],
+                                stdin = p[0],
+                                stdout = "/dev/null",
+                                stderr = "/dev/null",
+                                searchPath = 1)
+
+    os.close(p[0])
+    if rc:
+        raise CryptoError("luks_remove_key failed")
+
+
diff -urN --exclude .git --exclude po/ --exclude '*.pyc' --exclude '.*.swp' anaconda/storage/devicelibs/dm.py anaconda-storage/storage/devicelibs/dm.py
--- anaconda/storage/devicelibs/dm.py	1969-12-31 18:00:00.000000000 -0600
+++ anaconda-storage/storage/devicelibs/dm.py	2009-02-12 16:17:59.000000000 -0600
@@ -0,0 +1,77 @@
+import os
+import iutil
+
+import gettext
+_ = lambda x: gettext.ldgettext("anaconda", x)
+
+import logging
+log = logging.getLogger("storage")
+
+class DMError(Exception):
+    pass
+
+def name_from_dm_node(dm_node):
+    st = os.stat("/dev/%s" % dm_node)
+    major = os.major(st.st_rdev)
+    minor = os.minor(st.st_rdev)
+    name = iutil.execWithCapture("dmsetup",
+                                 ["info", "--columns",
+                                  "--noheadings", "-o", "name",
+                                  "-j", str(major), "-m", str(minor)],
+                                 stderr="/dev/null")
+    log.debug("name_from_dm(%s) returning '%s'" % (dm_node, name.strip()))
+    return name.strip()
+
+def dm_node_from_name(map_name):
+    devnum = iutil.execWithCapture("dmsetup",
+                                   ["info", "--columns",
+                                    "--noheadings",
+                                    "-o", "devno",
+                                    map_name],
+                                    stderr="/dev/null")
+    (major, sep, minor) = devnum.strip().partition(":")
+    if not sep:
+        raise DMError("dm device does not exist")
+
+    dm_node = "dm-%d" % int(minor)
+    log.debug("dm_node_from_name(%s) returning '%s'" % (map_name, dm_node))
+    return dm_node
+
+def _get_backing_devnums_from_map(map_name):
+    ret = []
+    buf = iutil.execWithCapture("dmsetup",
+                                ["info", "--columns",
+                                 "--noheadings",
+                                 "-o", "devnos_used",
+                                 map_name],
+                                stderr="/dev/null")
+    dev_nums = buf.split()
+    for dev_num in dev_nums:
+        (major, colon, minor) = dev_num.partition(":")
+        ret.append((int(major), int(minor)))
+
+    return ret
+
+def get_backing_devnums(dm_node):
+    #dm_node = dm_node_from_name(map_name)
+    if not dm_node:
+        return None
+
+    top_dir = "/sys/block"
+    backing_devs = os.listdir("%s/%s/slaves/" % (top_dir, dm_node))
+    dev_nums = []
+    for backing_dev in backing_devs:
+        dev_num = open("%s/%s/dev" % (top_dir, backing_dev)).read().strip()
+        (_major, _minor) = dev_num.split(":")
+        dev_nums.append((int(_major), int(_minor)))
+
+    return dev_nums
+
+def get_backing_devs_from_name(map_name):
+    dm_node = dm_node_from_name(map_name)
+    if not dm_node:
+        return None
+
+    slave_devs = os.listdir("/sys/block/virtual/%s" % dm_node)
+    return slave_devs
+
diff -urN --exclude .git --exclude po/ --exclude '*.pyc' --exclude '.*.swp' anaconda/storage/devicelibs/lvm.py anaconda-storage/storage/devicelibs/lvm.py
--- anaconda/storage/devicelibs/lvm.py	1969-12-31 18:00:00.000000000 -0600
+++ anaconda-storage/storage/devicelibs/lvm.py	2009-02-16 18:38:41.000000000 -0600
@@ -0,0 +1,330 @@
+
+import math
+
+import iutil
+import gettext
+_ = lambda x: gettext.ldgettext("anaconda", x)
+
+class LVMError(Exception):
+    pass
+
+def getPossiblePhysicalExtents(floor=0):
+    """Returns a list of integers representing the possible values for
+       the physical extent of a volume group.  Value is in KB.
+
+       floor - size (in KB) of smallest PE we care about.
+    """
+
+    possiblePE = []
+    curpe = 8
+    while curpe <= 16384*1024:
+	if curpe >= floor:
+	    possiblePE.append(curpe)
+	curpe = curpe * 2
+
+    return possiblePE
+
+def getMaxLVSize(pe):
+    """Given a PE size in KB, returns maximum size (in MB) of a logical volume.
+
+    pe - PE size in KB
+    """
+    if iutil.getArch() in ("x86_64", "ppc64"): #64bit architectures
+        return (8*1024*1024*1024*1024) #Max is 8EiB (very large number..)
+    else:
+        return (16*1024*1024) #Max is 16TiB
+
+def safeLvmName(str):
+    tmp = string.strip(str)
+    tmp = tmp.replace("/", "_")
+    tmp = re.sub("[^0-9a-zA-Z._]", "", str)
+    tmp = tmp.lstrip("_")
+
+    return tmp
+
+def createSuggestedVGName(partitions, network):
+    """Given list of partition requests, come up with a reasonable VG name
+
+    partitions - list of requests
+    """
+
+    # try to create a volume group name incorporating the hostname
+    hn = network.hostname
+    if hn is not None and hn != '':
+        if hn == 'localhost' or hn == 'localhost.localdomain':
+            vgtemplate = "VolGroup"
+        elif hn.find('.') != -1:
+            hn = safeLvmName(hn)
+            vgtemplate = "vg_%s" % (hn.split('.')[0].lower(),)
+        else:
+            hn = safeLvmName(hn)
+            vgtemplate = "vg_%s" % (hn.lower(),)
+    else:
+        vgtemplate = "VolGroup"
+
+    if not partitions.isVolumeGroupNameInUse(vgtemplate):
+        return vgtemplate
+    else:
+        i = 0
+        while 1:
+            tmpname = "%s%02d" % (vgtemplate, i,)
+            if not partitions.isVolumeGroupNameInUse(tmpname):
+                break
+
+            i += 1
+            if i > 99:
+                tmpname = ""
+
+        return tmpname
+
+def createSuggestedLVName(logreqs):
+    """Given list of LV requests, come up with a reasonable LV name
+
+    partitions - list of LV requests for this VG
+    """
+
+    i = 0
+
+    lnames = []
+    for lv in logreqs:
+        lnames.append(lv.logicalVolumeName)
+
+    while 1:
+        tmpname = "LogVol%02d" % (i,)
+        if (logreqs is None) or (tmpname not in lnames):
+            break
+
+        i += 1
+        if i > 99:
+            tmpname = ""
+
+    return tmpname
+
+def getVGUsedSpace(vgreq, requests, diskset):
+    vgused = 0
+    for request in requests.requests:
+	if request.type == REQUEST_LV and request.volumeGroup == vgreq.uniqueID:
+	    size = int(request.getActualSize(requests, diskset))
+	    vgused = vgused + size
+
+
+    return vgused
+
+def getVGFreeSpace(vgreq, requests, diskset):
+    raise NotImplementedError
+    used = getVGUsedSpace(vgreq, requests, diskset)
+    log.debug("used space is %s" % (used,))
+    
+    total = vgreq.getActualSize(requests, diskset)
+    log.debug("actual space is %s" % (total,))
+    return total - used
+
+def clampSize(size, pesize, roundup=None):
+    if roundup:
+        round = math.ceil
+    else:
+        round = math.floor
+
+    return long(round(float(size)/float(pesize)) * pesize)
+
+def pvcreate(device):
+    rc = iutil.execWithRedirect("lvm",
+                                ["pvcreate", device],
+                                stdout = "/dev/null",
+                                stderr = "/dev/null",
+                                searchPath=1)
+    if rc:
+        raise LVMError("pvcreate failed for %s" % device)
+
+def pvresize(device, size):
+    size_arg = "%dm" % size
+    rc = iutil.execWithRedirect("lvm",
+                                ["pvresize",
+                                 "--setphysicalvolumesize", size_arg,
+                                 device],
+                                stdout = "/dev/null",
+                                stderr = "/dev/null",
+                                searchPath=1)
+    if rc:
+        raise LVMError("pvresize failed for %s" % device)
+
+def pvremove(device):
+    rc = iutil.execWithRedirect("lvm",
+                                ["pvremove", device],
+                                stdout = "/dev/null",
+                                stderr = "/dev/null",
+                                searchPath=1)
+    if rc:
+        raise LVMError("pvremove failed for %s" % device)
+
+def pvinfo(device):
+    """
+        If the PV was created with '--metadacopies 0', lvm will do some
+        scanning of devices to determine from their metadata which VG
+        this PV belongs to.
+
+        pvs -o pv_name,pv_mda_count,vg_name,vg_uuid --config \
+            'devices { scan = "/dev" filter = ["a/loop0/", "r/.*/"] }'
+    """
+    #cfg = "'devices { scan = \"/dev\" filter = [\"a/%s/\", \"r/.*/\"] }'" 
+    rc = iutil.execWithCapture("lvm",
+                               ["pvs", "--noheadings",
+                                "--units", "m",
+                                "-o",
+                                "pv_name,pv_mda_count,vg_name,vg_uuid",
+                                device],
+                                stderr = "/dev/null")
+    vals = rc.split()
+    if not vals:
+        raise LVMError("pvinfo failed for %s" % device)
+
+    info = {'pv_name': vals[0],
+            'vg_name': vals[2],
+            'vg_uuid': vals[3]}
+    return info
+
+def vgcreate(vg_name, pvs, pe_size):
+    argv = ["vgcreate"]
+    if pe_size:
+        argv.extend(["-s", "%dM" % pe_size])
+    pv_list = " ".join(pvs)
+    argv.append(vg_name)
+    argv.append(pv_list)
+    rc = iutil.execWithRedirect("lvm",
+                                argv,
+                                stdout = "/dev/null",
+                                stderr = "/dev/null",
+                                searchPath=1)
+
+    if rc:
+        raise LVMError("vgcreate failed for %s" % vg_name)
+
+def vgremove(vg_name):
+    rc = iutil.execWithRedirect("lvm", ["vgremove", vg_name],
+                                stdout = "/dev/null",
+                                stderr = "/dev/null",
+                                searchPath=1)
+
+    if rc:
+        raise LVMError("vgremove failed for %s" % vg_name)
+
+def vgactivate(vg_name):
+    rc = iutil.execWithRedirect("lvm", ["vgchange" "-a", "y", vg_name],
+                                stdout = "/dev/null",
+                                stderr = "/dev/null",
+                                searchPath=1)
+    if rc:
+        raise LVMError("vgactivate failed for %s" % vg_name)
+
+def vgdeactivate(vg_name):
+    rc = iutil.execWithRedirect("lvm", ["vgchange", "-a", "n", vg_name],
+                                stdout = "/dev/null",
+                                stderr = "/dev/null",
+                                searchPath=1)
+
+    if rc:
+        raise LVMError("vgdeactivate failed for %s" % vg_name)
+
+def vgreduce(vg_name, pv_list):
+    pvs = " ".join(pv_list)
+    rc = iutil.execWithRedirect("lvm", ["vgreduce", vg_name, pvs],
+                                stdout = "/dev/null",
+                                stderr = "/dev/null",
+                                searchPath=1)
+
+    if rc:
+        raise LVMError("vgreduce failed for %s" % vg_name)
+
+def vginfo(vg_name):
+    buf = iutil.execWithCapture("lvm",
+                ["vgs", "--noheadings", "--nosuffix", "--units", "m", "-o", 
+                 "uuid,size,free,extent_size,extent_count,free_count,pv_count",
+                 vg_name],
+                 stderr="/dev/null")
+    info = buf.split()
+    if len(info) != 7:
+        raise LVMError(_("vginfo failed for %s" % vg_name))
+
+    d = {}
+    (d['uuid'],d['size'],d['free'],d['pe_size'],
+     d['pe_count'],d['pe_free'],d['pv_count']) = info
+    return d
+
+def lvs(vg_name):
+    buf = iutil.execWithCapture("lvm",
+                                ["lvs", "--noheadings", "--nosuffix",
+                                 "--units", "m", "-o",
+                                 "lv_name,lv_uuid,lv_size"],
+                                stderr="/dev/null")
+
+
+    lvs = {}
+    for line in buf.splitlines():
+        line = line.strip()
+        if not line:
+            continue
+        (name, uuid, size) = line.split()
+        lvs[name] = {"size": size,
+                     "uuid": uuid}
+    return lvs
+
+def lvcreate(vg_name, lv_name, size):
+    size_arg = "%dm" % size
+    rc = iutil.execWithRedirect("lvm",
+                                ["lvcreate",
+                                 "-L", size_arg,
+                                 "-n", lv_name,
+                                 vg_name],
+                                stdout = "/dev/null",
+                                stderr = "/dev/null",
+                                searchPath=1)
+
+    if rc:
+        raise LVMError("lvcreate failed for %s/%s" % (vg_name, lv_name))
+
+def lvremove(vg_name, lv_name):
+    lv_path = "%s/%s" % (vg_name, lv_name)
+    rc = iutil.execWithRedirect("lvm", ["lvremove", lv_path],
+                                stdout = "/dev/null",
+                                stderr = "/dev/null",
+                                searchPath=1)
+
+    if rc:
+        raise LVMError("lvremove failed for %s" % lv_path)
+
+def lvresize(vg_name, lv_name, size):
+    lv_path = "%s/%s" % (vg_name, lv_name)
+    size_arg = "%dm" % size
+    rc = iutil.execWithRedirect("lvm",
+                                ["lvresize",
+                                 "-L", size_arg,
+                                 lv_path],
+                                stdout = "/dev/null",
+                                stderr = "/dev/null",
+                                searchPath=1)
+
+    if rc:
+        raise LVMError("lvresize failed for %s" % lv_path)
+
+def lvactivate(vg_name, lv_name):
+    # see if lvchange accepts paths of the form 'mapper/$vg-$lv'
+    lv_path = "%s/%s" % (vg_name, lv_name)
+    rc = iutil.execWithRedirect("lvm", ["lvchange", "-a", "y", lv_path],
+                                stdout = "/dev/null",
+                                stderr = "/dev/null",
+                                searchPath=1)
+    if rc:
+        raise LVMError("lvactivate failed for %s" % lv_path)
+
+def lvdeactivate(vg_name, lv_name):
+    lv_path = "%s/%s" % (vg_name, lv_name)
+    rc = iutil.execWithRedirect("lvm", ["lvchange", "-a", "n", lv_path],
+                                stdout = "/dev/null",
+                                stderr = "/dev/null",
+                                searchPath=1)
+
+    if rc:
+        raise LVMError("lvdeactivate failed for %s" % lv_path)
+
+
+
